// Auto-generated. Do not edit!

// (in-package rc_silhouettematch_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let RegionOfInterest = require('../msg/RegionOfInterest.js');

//-----------------------------------------------------------

let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class SetRegionOfInterestRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.region_of_interest_2d = null;
    }
    else {
      if (initObj.hasOwnProperty('region_of_interest_2d')) {
        this.region_of_interest_2d = initObj.region_of_interest_2d
      }
      else {
        this.region_of_interest_2d = new RegionOfInterest();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetRegionOfInterestRequest
    // Serialize message field [region_of_interest_2d]
    bufferOffset = RegionOfInterest.serialize(obj.region_of_interest_2d, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetRegionOfInterestRequest
    let len;
    let data = new SetRegionOfInterestRequest(null);
    // Deserialize message field [region_of_interest_2d]
    data.region_of_interest_2d = RegionOfInterest.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += RegionOfInterest.getMessageSize(object.region_of_interest_2d);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/SetRegionOfInterestRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '3b4a223057c0a268465ea4bbf32793ad';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Sets a region of interest.
    
    # Required
    RegionOfInterest region_of_interest_2d
    
    
    ================================================================================
    MSG: rc_silhouettematch_client/RegionOfInterest
    # Region of Interest.
    # If width and height are both 0, the full image is covered
    
    # id of the ROI
    string id
    
    # leftmost pixel of the ROI
    uint32 offset_x
    
    # topmost pixel of the ROI
    uint32 offset_y
    
    # width of ROI
    uint32 width
    
    # height of ROI.
    uint32 height
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetRegionOfInterestRequest(null);
    if (msg.region_of_interest_2d !== undefined) {
      resolved.region_of_interest_2d = RegionOfInterest.Resolve(msg.region_of_interest_2d)
    }
    else {
      resolved.region_of_interest_2d = new RegionOfInterest()
    }

    return resolved;
    }
};

class SetRegionOfInterestResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetRegionOfInterestResponse
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetRegionOfInterestResponse
    let len;
    let data = new SetRegionOfInterestResponse(null);
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_silhouettematch_client/SetRegionOfInterestResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '89940768eec602f7650f8f061383e0f9';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetRegionOfInterestResponse(null);
    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: SetRegionOfInterestRequest,
  Response: SetRegionOfInterestResponse,
  md5sum() { return '516bc5dcdaef3e02f0559d8b73ecf714'; },
  datatype() { return 'rc_silhouettematch_client/SetRegionOfInterest'; }
};
